' These are some starter routines
' that will help you use the PAK-8
' Coprocessor from AWC
' For PIC Basic Pro V2.40

Include "modedefs.bas"
define LOADER_USED 1  ' comment this out if not using a boot loader
Define OSC 20


' Change these to suit your setup
datap var portc.2   ' Data pin (I/O)
datapin var portc.2
clk var portc.3     ' Clk pin (output)

' Register names
DURLOW con %000
DURHIGH con %001
HIGHDUR con %010
LOWDUR con %011
PSCALE con %100
PSBASE con %101
N con %110
CTRL con %111


output clk
output datap

fpx var word        ' Integer used by some routines
fpb var byte        ' byte
' parameters for FCommand
chan var byte
register var byte

pause 10
gosub freset        ' always reset!

' TEST CODE -- REPLACE WITH YOUR OWN
' This program blinks an LED on the PAK's port 0 at 1Hz
t:
gosub FTotalReset  ' hard reset


top:

chan=0
register=1
fpx=50000    ' 500 ms on and off = 500ms period = 1Hz
gosub FCommand
register=2   ' no need to set register again
gosub FCommand
' turn on pulse operation of channel 0
fpb=3
gosub FJam

stopit:
goto stopit

' End of your code -- everything from here down is library code

' Reset the Pak8 I/O
FReset:
LOW DATAP
LOW CLK
pauseus 50   ' might be able to reduce these pauses if necessary
HIGH CLK
pauseus 50
HIGH DATAP
pauseus 50
LOW CLK     
pauseus 50
return

' 0 is 0, 1 is 1, 2 is hi-z, 3 is normal
' note: 3 enables channel to run!
FJam:
fpb=chan + (fpb<<3)+%01000000
goto FSendByte

FCommand:
' inputs chan = channel, register = register
 fpb=(register<<3) + chan
 gosub FSendByte
 fpb=fpx.lowbyte
 gosub FSendByte
 fpb=fpx.highbyte
 goto FSendByte
 

FReadReg:
 fpb=(register<<3) + chan + %10000000
 gosub FSendByte
' fall into FReadWord


FReadWord:
  Shiftin datap,clk,MSBPRE,[fpx.lowbyte,fpx.highbyte]
  return

FTotalReset:
  fpb=$FF
FSendByte:
  Shiftout datap,clk,MSBFIRST,[fpb]
  return

FReadByte:
  shiftin datap,clk,MSBPRE,[fpb]
  return

FPrescale:
' set fpb to the prescale constant
  fpb = fpb + $C0
  goto FSendByte
  

